% ParabolicEquationBC_SSA.m:
% Script testing path loss

% create file:
testResults = 'testResults_irregularTerrain.txt';
fileID = fopen(testResults, 'w');
fprintf(fileID, '%s\r\n', 'Comparing with analytical model');
fprintf(fileID, '%s\r\n', ' ');
eField = 0;
distance = 1000;
frequency  = 100*10^6;
fprintf(fileID, '%s', 'Frequency: ');
fprintf(fileID, '%e Hz\r\n', frequency);
fprintf(fileID, '%s\r\n', 'Distance: ');
maxX = 3000;
fprintf(fileID, '%5.1f\r\n', maxX);

theta0 = 0;
beta = pi/15; % 0.5;
A = 2;


fprintf(fileID, '%s\r\n', ' ');

% Setting deltaZ:
deltaZarr =1; %1.5; %[0.5 1 1.5]; %1.5;%1.5; %0.5; %1.5; % [0.3 0.7 1.5]; % [0.3 0.2 0.1 0.09]; %[1.5 1 0.9 0.6 0.3 0.06];% [0.01 0.05 0.09 0.9];% [0.006 0.009 0.01 0.05 0.09 0.9];
antHeight =10; %3; % 25; % 7.5; %[2.5 3 7.5 10]; % 25];
maxHinterestArr = 20; %50; % 200; % [8 10 14 25 50 200]; % [2 3 4 5 6 7 8];
gVect = 1.1; %1.3; %[1.1 1.3 1.5 1.9]; %[0.001 0.01 0.1 1.1];
deltaXvect = 1; %[1 1.5]; %[0.7 1 1.2 1.5];
numElts = length(deltaZarr)*length(antHeight)*length(maxHinterestArr)...
    *length(gVect)*length(deltaXvect);
counter = 0;
simulationType {length(numElts),1} = [];
numPointsLayer = 100;
for b = 1: length(deltaZarr)
    b
    deltaZ = deltaZarr(b);
    
    fprintf(fileID, '%s\r\n', ' ');
    fprintf(fileID, '%s\r\n', ' ');
    fprintf(fileID, '%s', 'Delta z: ');
    fprintf(fileID, '%4.3f\r\n', deltaZ );
    fprintf(fileID, '%s\r\n', ' ');
    
    
    for a = 1:length(antHeight)
        a
        zs = antHeight(a); % 7.5;
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s', '    Antenna height: ');
        fprintf(fileID, '%4.2f m\r\n', zs);
        tx = zs;
        rx = zs;
        
        
        for h = 1: length(maxHinterestArr)
            
            maxHinterest = maxHinterestArr(h)*zs;
            fprintf(fileID, '%s\r\n', ' ');
            fprintf(fileID, '%s', '        Max height of interest:');
            fprintf(fileID, '%4.3f\r\r\n', maxHinterest);
            fprintf(fileID, '%s\r\n', ' ');
            
            fprintf(fileID, '%s\r\n', ' ');
            
            
            
            
            
            for m =1:length(gVect)
                %deltaZfdm = 0.009- m*0.003; %0.009:-0.002:0.001
                %m
                g = gVect(m);
                %g
                fprintf(fileID, '%s\r\n', ' ');
                fprintf(fileID, '%s', '        New g value:');
                fprintf(fileID, '%4.3f\r\r\n', g);
                fprintf(fileID, '%s\r\n', ' ');
                
                deltaXvect = 1; %[1.5]; % [0.5 0.7 1 1.2 1.5];
                
                for n = 1:length(deltaXvect)
                    counter = counter +1;
                    sourceShape = 'gaussian1';
                    
                    % Creating zVect and initial field:
                    [zVectSSA,HindexSSA] =createZvectAbsorptionLayer2(maxHinterest,deltaZ,100);
                    
                    % The irregular terrain:
                    wedgeHeight = 10;
                    Xn = [0, 1500, 3000];
                    Zn = [0, wedgeHeight, 0];
                    deltaX = deltaXvect(n); %
                    [xVect,zSurfaceVect] = interpolate(Xn,Zn,frequency,'linear',deltaX);
                    xVect = verticalVector(xVect); %[0:deltaX:maxX]);
                    
                    initialFieldSSA = createInitialField(zs,theta0,beta,zVectSSA,A, frequency,sourceShape);
                    
                    fprintf(fileID, '%s', '            New delta x value: ');
                    fprintf(fileID, '%4.3f\r\n', deltaX);
                    
                    %xVect = verticalVector([0:deltaX:maxX]);
                    alpha = -0.1;
                    % Calculating the field:%                     uValuesSplitStep = SSA_AbsorptionLayer_BC(initialFieldSSA,zVectSSA,xVect, ...
                    %                         HindexSSA,frequency,g,alpha);
                    disp('begynner utregning');
                    tic
%                     uValuesSplitStep = splitStepAlgorithmIrregularTerrain ...
%                         (initialFieldSSA,zVectSSA,xVect,zSurfaceVect,frequency);
                    size(zVectSSA)
                    size(initialFieldSSA)
                    uValuesSplitStep = SSAirregularTerrainAbsoptionLayer(initialFieldSSA,zVectSSA,...
    xVect,zSurfaceVect,HindexSSA,frequency,numPointsLayer,zs);
                    toc
                                     
                    rx_zArr = zVectSSA;
                    
                    rx_xArr = ones(length(zVectSSA),1).*length(xVect);
                    %eField1 = uValuesSplitStep(ceil(HindexSSA*(zs/maxHinterest)):ceil(HindexSSA*(zs/maxHinterest)),:);
                    simulationType{counter,1} = ['SSA:', ' ','\Deltax =', ' ', ...
                        num2str(deltaXvect(n)),', max h: ', ...
                        ' ', num2str(maxHinterestArr(h)), ', ', '\Deltaz =',...
                        ' ',num2str(deltaZ),', ', 'Ant. h: ',num2str(antHeight(a))];
                    eField1 = zeros(length(zVectSSA),1);
                    for i = 1:length(zVectSSA)
                        %disp('henter verdier')
                        %i
                        eField1(i,1) = uValuesSplitStep(i,rx_xArr(i));
                        %disp('har fatt verdien')
                    end
                    
                    % Plotting both eFields in the same plot
                    if counter == 1
                        disp('gaar dette bra?');
                        eFieldTot = eField1;
                        disp('Ja!');
                        %uValuesTot = uValuesSplitStep;
                    else
                        eFieldTot = vertcat(eFieldTot,eField1); %,eField2);
                        %uValuesTot = horzcat(uValuesTot,uValuesSplitStep);
                    end
                end
            end
            disp('Skal plotte feltet');
            fig = figure('visible','off');
            part1Title = ['SSA - irregular terrain , ant h.:',...
                        ' ',num2str(antHeight(a)), ...
                        ' ','\Deltaz = ',' ',num2str(deltaZ),', ','\Deltax = ',' ', ...
                        num2str(deltaX),', ','Max h: ',...
                        num2str(maxHinterestArr(h))];
            part2Title = ['Num pts absorption layer: ',...
                num2str(numPointsInLayer)];
            part3Title = ['Wedge height: ',num2str(wedgeHeight)];
                    
                    %                         'Number ',...
                    %                     'of layers:'...
                    %                     ,' ', num2str(numLayers),', Number of points per'...
                    %                     ,' layer: ',num2str(numPointsPerLayer)]
            titleVal2 = {part1Title;part2Title;part3Title};
            %contourf(abs(uValuesFiniteDiffMethod).^2,50)
            auxUvalues = uValuesSplitStep;
            auxUvalues(abs(auxUvalues)<10^-3) = 10^4;
            contourf(10.*log10(abs(auxUvalues).^2),50)
            hold on
            contour(10.*log10(abs(auxUvalues).^2),50)
            title(titleVal2)
            xlabel('The surface');
            ylabel('Height above surface')
            grid on
            titleFig = ['SSA_irregular_terrain_results/SSA_irregular_',...
                'terrain_ant_h_','_',num2str(antHeight(a)), ...
                 '_','Deltaz','_',num2str(deltaZ),'_','Deltax_','_', ...
                 num2str(deltaX),'_max_h_',...
                 num2str(maxHinterestArr(h)), ...
                'num_points_layer', num2str(numPointsInLayer),...
                'wedge_height',num2str(wedgeHeight) ,'.png'];
            saveas(fig,titleFig,'png');            
        end
       
        
    end
end
titleVal3 = ['SSA - analytical beam param irregular terrain',', ', 'Source shape:',' ', ...
    sourceShape];
% pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
%     beta,frequency,simulationType, titleVal3);

%%
rx_xArr = ones(length(rx_xArr),1)*xVect(length(xVect));
pathLossWedge_beamParam(Xn,Zn,deltaX,A,tx,rx_xArr,rx_zArr,eFieldTot,zs,...
    beta,frequency,simulationType, titleVal3)
%%
fclose(fileID);








