% importFieldResultsFromFile.m:Imports field results from a specified file,
%                              with the e-field values in column 4, the
%                              z-values in a column to be specified. The 
%                              function is adjusted to the format of the 
%                              results from Indra.  

% fileName: String containing the file name
% column: Column number containing desired range column.

function [eFieldValues,zVect]=importFieldResultsFromFile(fileName,column)

fileValues = xlsread(fileName);

eFieldValues = fileValues(:,4);
zVect = fileValues(:,column);

end








