% normalizeSurface.m: Shifts the surface heights so that lowest point is
%                     situated at height 0.
% zSurfaceVect: The initital heights of the surface
% return:
%         zSurfaceNorm: The normalized heights of the surface.
%         truncationValue: The height level the surface is shifted with 


function [zSurfaceNorm,truncationValue]=normalizeSurface(zSurfaceVect)

minVal = min(zSurfaceVect);

truncationValue = -minVal;
zSurfaceNorm = truncationValue + zSurfaceVect;
end

