% testInitialField.m: testing how the parameters changes the initial field
close all
zs = 2*7.5;
frequency = 100*10^6;
theta0 = [0]; % pi/6]; %, pi/4];
beta =[pi/15 pi/6, pi/4];
A=10;
deltaZ = 0.9;
maxHinterest = 3*zs;
[zVect,HindexFDM] =createZvectAbsorptionLayer(maxHinterest,deltaZ);
% initialField = createInitialField(zs,theta0,beta,zVect,A, frequency, 'gaussian1');
%             plot(zVect,abs(initialField)); %,'Color',cmap(plotnum,:))

source{3,1} = [];

source{1,1} = 'gaussian1';
source{2,1} = 'gaussian2';
source{3,1} = 'circular';
%source = ['gaussian1'; 'gaussian2'];

for s = 1:3% length(source)
    figure()
    plotNames = cell(length(beta)*length(theta0),1);
    counter = 0;
    for t = 1:length(theta0)
       
        disp('hei');
        
        
        plotnum = 0;
        
        %title('Initial field');% - elevation angle constant, beamwidth varying');
        xlabel('Height above surface');
        ylabel('Field strength')
        cmap = hsv(length(beta)*length(theta0));
        for b = 1:length(beta)
            
            counter = counter +1;
            plotnum = plotnum +1;
            hold on
            initialField = createInitialField(zs,theta0(t),beta(b),zVect,A, frequency, source{s,1});
            %plot(zVect,abs(initialField),'Color',cmap(counter,:))
            plot(abs(initialField),'Color',cmap(counter,:))
            myName =  ['t =',' ',num2str(theta0(t)),', ','beta =', ' ',num2str(beta(b)), ' '];
            plotNames{counter,1} = myName;
        end
        
        
    end
    plotNames
    legend(plotNames);
end