% Script testing path loss

% create file:
testResults = 'testResults_FDM2_newField_newBeta.txt';
fileID = fopen(testResults, 'w');
fprintf(fileID, '%s\r\n', 'Testing for stability, varying delta z, antenna height, the g-value (refractive index) and delta x:');
fprintf(fileID, '%s\r\n', ' ');
eField = 0;
distance = 1000;
frequency  = 100*10^6;
fprintf(fileID, '%s', 'Frequency: ');
fprintf(fileID, '%e Hz\r\n', frequency);
fprintf(fileID, '%s\r\n', 'Distance: ');
maxX = 3000;
fprintf(fileID, '%5.1f\r\n', maxX);


fprintf(fileID, '%s\r\n', ' ');

% Setting deltaZ:
deltaZarr = [0.3 0.2 0.1 0.09]; %[1.5 1 0.9 0.6 0.3 0.06];% [0.01 0.05 0.09 0.9];% [0.006 0.009 0.01 0.05 0.09 0.9];
for b = 1:length(deltaZarr)
    b
    deltaZfdm = deltaZarr(b); %0.009; % 0.08; %0.1;
    deltaZfdm
    fprintf(fileID, '%s\r\n', ' ');
    fprintf(fileID, '%s\r\n', ' ');
    fprintf(fileID, '%s', 'Delta z: ');
    fprintf(fileID, '%4.3f\r\n', deltaZfdm);
    fprintf(fileID, '%s\r\n', ' ');
    
    antHeight = [2 7.5 10]; % 25];
    for a = 1:length(antHeight)
        a
        zs = antHeight(a); % 7.5;
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s', '    Antenna height: ');
        fprintf(fileID, '%4.2f m\r\n', zs);
        tx = zs;
        rx = zs;
        
        
        
        
        maxHinterest = 2*zs;
        %zs = 7.5;
        theta0 = 0;
        beta = 0.5;
        A = 1;
        frequency = 100*10^6;
        
        
        fprintf(fileID, '%s\r\n', ' ');
        
        deltaZssa = 0.7; %0.9;
        %deltaXfdmArr = [0.9 0.09 0.009 0.006 0.003];
        deltaXvect = [1 1.5]; %[0.7 1 1.2 1.5];
        gVect = 1.3; %[1.1 1.3 1.5 1.9]; %[0.001 0.01 0.1 1.1];
        
        
        for m =1:length(gVect)
            %deltaZfdm = 0.009- m*0.003; %0.009:-0.002:0.001
            m
            g = gVect(m);
            g
            fprintf(fileID, '%s\r\n', ' ');
            fprintf(fileID, '%s', '        New g value:');
            fprintf(fileID, '%4.3f\r\r\n', g);
            fprintf(fileID, '%s\r\n', ' ');
            
            deltaXvect =[0.5 1 1.5]; % [0.5 0.7 1 1.2 1.5];
            simulationType {2*length(deltaXvect),1} = []; 
            for n = 1:length(deltaXvect)
                
                %deltaZfdm = deltaXfdmArr(m);
                %deltaZfdm = 0.09;
                %deltaZoverZs = deltaZfdm/zs;
                % Creating zVect and initial field:
                disp('hei')
                maxHinterest
                deltaZssa
                [zVectSSA,HindexSSA] =createZvectAbsorptionLayer(maxHinterest,deltaZssa);
                initialFieldSSA = createInitialField(zs,theta0,beta,zVectSSA,A, frequency,'gaussian1');
                disp('heihei')
                % Creating zVect and initial field:
                [zVectFDM,HindexFDM] =createZvectAbsorptionLayer(maxHinterest,deltaZfdm);
                zVectFDM = zVectFDM((1:HindexFDM*1.5),1);
                initialFieldFDM = createInitialField(zs,theta0,beta,zVectFDM,A, frequency,'gaussian1');
                %plot(abs(initialFieldFDM))
                
                % Creating xVect:
                deltaX = deltaXvect(n);  %1.0;
                deltaX
                
                xVect = verticalVector(linspace(0,maxX,length(zVectFDM)));
                
                %deltaX = 1; % xVect(2,1) - xVect(1,1);
                %xVect = verticalVector([0:deltaX:maxX]);
                
                fprintf(fileID, '%s', '            New delta x value: ');
                fprintf(fileID, '%4.3f\r\n', deltaX);
                %3000;
                %xVect = verticalVector([0:deltaX:maxX]);
                
                
                % Calculating the field:
                uValuesSplitStep = splitStepAlgorithmAbsorptionLayer(initialFieldSSA,zVectSSA,xVect, ...
                    HindexSSA,frequency);
         
                tic
                [uValuesFDMalne,maxEigVal] = FDMAbsorptionLayerNumEfficient(initialFieldFDM, ...
                   zVectFDM,xVect,HindexFDM,frequency,g);
                toc
                fprintf(fileID, '%s', '                Maximum eigenvalue:');
                fprintf(fileID, '%4.6f\r\n', maxEigVal);
                
                
                
                %save('testPathLossZS100')
                
                
                %close all;
                eField1 = uValuesSplitStep(ceil(HindexSSA*(zs/maxHinterest)):ceil(HindexSSA*(zs/maxHinterest)),:);
                %simulationType1 = cell(1);
                %simulationType1{1} = 'Split-Step Algorithm';
                simulationType{(2*n)-1,1} = ['SSA:', ' ','\Deltax =', ' ', num2str(deltaXvect(n))];
                %pathLossFlat(tx,rx,xVect,eField1,zs, frequency, simulationType1,'r')
                 if n == 1
                    eFieldTot = eField1;
                else
                    eFieldTot = vertcat(eFieldTot,eField1); %,eField2);
                end
                
                eField2 = uValuesFDMalne(ceil(HindexFDM*(zs/maxHinterest)):ceil(HindexFDM*(zs/maxHinterest)),:);
                %eField3 = uValuesFiniteDiffMethod(ceil(HindexFDM*(zs/maxHinterest)):ceil(HindexFDM*(zs/maxHinterest)),:);
                %simulationType2 = cell(1);
                %simulationType2{1} = 'Finite-Difference Method';
                %pathLossFlat(tx,rx,xVect,eField3,zs, frequency, simulationType2,'r')
                % %% Plotting path loss for two e-fields
                %close all
                % Plotting both eFields in the same plot
                eFieldTot = vertcat(eFieldTot,eField2);
                simulationType{2*n,1} = ['FDM:', ' ','\Deltax =', ' ', num2str(deltaXvect(n))];
                %simulationType = {'Split-Step Algorithm', 'Finite-Difference Method Num Eff'};
                %simulationType{1} ='Split-Step Algorithm';
                %simulationtype{2} = 'Finite-Difference Method';
                 end
                colors = ['g','r', 'y', 'm', 'c','k'];
                title = ['Pahtloss for antenna height:', ' ', num2str(antHeight(a)), 'm'];
                pathLossFlat(tx,rx,xVect,eFieldTot,zs, frequency, simulationType,colors,title)
                
%                 figure()
%                 %contourf(abs(uValuesFiniteDiffMethod).^2,50)
%                 contourf(10.*log10(abs(uValuesFDMalne(1:1.5*HindexFDM,:)).^2),20)
%                 title('E-field - Finite-Difference Method')
%                 xlabel('The surface');
%                 ylabel('Height above surface')
%                 grid on
                
                
           
        end
    end
end
fclose(fileID);
%%
close all
% Plotting both eFields in the same plot
eFieldTot = vertcat(eField1,eField2,eField3);
simulationType = {'Split-Step Algorithm', 'Finite-Difference Method Num Eff' ...
    ,'Finite-Difference Method'}; % cell(2);
%simulationType{1} ='Split-Step Algorithm';
%simulationtype{2} = 'Finite-Difference Method';
colors = ['b','r','g'];
pathLossFlat(tx,rx,xVect,eFieldTot,zs, frequency, simulationType,colors)
%%
close all
figure(1)
contourf(10.*log10(abs(uValuesSplitStep).^2),30)
%contourf(abs(uValuesSplitStep).^2,50)
title('E-field - Split-step Algorithm')
xlabel('The surface');
ylabel('Height above surface')
grid on







