% verticalVector.m
% Checks wether a vector is horizontal or vertical.
% If the vector is horizontal, it is transposed into being vertical.
% The returned vector is vertical

% Vin: Input vector (horizontal or vertical)
% Vout: Output vector, vertical

function [Vout] = verticalVector(Vin)

if( length(Vin(1,:)) > length(Vin(:,1)))
    % Vin is a horizontal vector
    Vout = Vin';
else
    Vout = Vin;
end
end